import { __decorate, __metadata } from 'tslib';
import { ɵɵdefineInjectable, Injectable, ɵɵinject, NgModule } from '@angular/core';
import { HttpResponse, HTTP_INTERCEPTORS } from '@angular/common/http';
import { throwError } from 'rxjs';
import { catchError, tap } from 'rxjs/operators';
import { CommonModule } from '@angular/common';

let HttpOverlayService = class HttpOverlayService {
    setOverlayCallBacks(before, after) {
        this.before = before;
        this.after = after;
    }
    callBefore() {
        if (!!this.before) {
            this.before();
        }
    }
    callAfter() {
        if (!!this.after) {
            this.after();
        }
    }
};
HttpOverlayService.ɵprov = ɵɵdefineInjectable({ factory: function HttpOverlayService_Factory() { return new HttpOverlayService(); }, token: HttpOverlayService, providedIn: "root" });
HttpOverlayService = __decorate([
    Injectable({
        providedIn: 'root'
    })
], HttpOverlayService);

let HttpOverlayInterceptor = class HttpOverlayInterceptor {
    constructor(httpOverlayService) {
        this.httpOverlayService = httpOverlayService;
    }
    intercept(req, next) {
        this.httpOverlayService.callBefore();
        return next
            .handle(req)
            .pipe(catchError((e, caught) => {
            this.httpOverlayService.callAfter();
            return throwError(e);
        }), tap(event => {
            if (event instanceof HttpResponse) {
                this.httpOverlayService.callAfter();
            }
        }));
    }
};
HttpOverlayInterceptor.ctorParameters = () => [
    { type: HttpOverlayService }
];
HttpOverlayInterceptor.ɵprov = ɵɵdefineInjectable({ factory: function HttpOverlayInterceptor_Factory() { return new HttpOverlayInterceptor(ɵɵinject(HttpOverlayService)); }, token: HttpOverlayInterceptor, providedIn: "root" });
HttpOverlayInterceptor = __decorate([
    Injectable({
        providedIn: 'root'
    }),
    __metadata("design:paramtypes", [HttpOverlayService])
], HttpOverlayInterceptor);

let HttpOverlayModule = class HttpOverlayModule {
};
HttpOverlayModule = __decorate([
    NgModule({
        imports: [
            CommonModule
        ],
        providers: [{
                provide: HTTP_INTERCEPTORS,
                useClass: HttpOverlayInterceptor,
                multi: true,
            },
            HttpOverlayService],
    })
], HttpOverlayModule);

/*
 * Public API Surface of a4-http-overlay-interceptor
 */

/**
 * Generated bundle index. Do not edit.
 */

export { HttpOverlayInterceptor, HttpOverlayModule, HttpOverlayService };
//# sourceMappingURL=a4-http-overlay-interceptor.js.map
