import { __decorate, __metadata } from 'tslib';
import { ɵɵdefineInjectable, Injectable, ɵɵinject, NgModule } from '@angular/core';
import { HttpResponse, HTTP_INTERCEPTORS } from '@angular/common/http';
import { throwError } from 'rxjs';
import { catchError, tap } from 'rxjs/operators';
import { CommonModule } from '@angular/common';

var HttpOverlayService = /** @class */ (function () {
    function HttpOverlayService() {
    }
    HttpOverlayService.prototype.setOverlayCallBacks = function (before, after) {
        this.before = before;
        this.after = after;
    };
    HttpOverlayService.prototype.callBefore = function () {
        if (!!this.before) {
            this.before();
        }
    };
    HttpOverlayService.prototype.callAfter = function () {
        if (!!this.after) {
            this.after();
        }
    };
    HttpOverlayService.ɵprov = ɵɵdefineInjectable({ factory: function HttpOverlayService_Factory() { return new HttpOverlayService(); }, token: HttpOverlayService, providedIn: "root" });
    HttpOverlayService = __decorate([
        Injectable({
            providedIn: 'root'
        })
    ], HttpOverlayService);
    return HttpOverlayService;
}());

var HttpOverlayInterceptor = /** @class */ (function () {
    function HttpOverlayInterceptor(httpOverlayService) {
        this.httpOverlayService = httpOverlayService;
    }
    HttpOverlayInterceptor.prototype.intercept = function (req, next) {
        var _this = this;
        this.httpOverlayService.callBefore();
        return next
            .handle(req)
            .pipe(catchError(function (e, caught) {
            _this.httpOverlayService.callAfter();
            return throwError(e);
        }), tap(function (event) {
            if (event instanceof HttpResponse) {
                _this.httpOverlayService.callAfter();
            }
        }));
    };
    HttpOverlayInterceptor.ctorParameters = function () { return [
        { type: HttpOverlayService }
    ]; };
    HttpOverlayInterceptor.ɵprov = ɵɵdefineInjectable({ factory: function HttpOverlayInterceptor_Factory() { return new HttpOverlayInterceptor(ɵɵinject(HttpOverlayService)); }, token: HttpOverlayInterceptor, providedIn: "root" });
    HttpOverlayInterceptor = __decorate([
        Injectable({
            providedIn: 'root'
        }),
        __metadata("design:paramtypes", [HttpOverlayService])
    ], HttpOverlayInterceptor);
    return HttpOverlayInterceptor;
}());

var HttpOverlayModule = /** @class */ (function () {
    function HttpOverlayModule() {
    }
    HttpOverlayModule = __decorate([
        NgModule({
            imports: [
                CommonModule
            ],
            providers: [{
                    provide: HTTP_INTERCEPTORS,
                    useClass: HttpOverlayInterceptor,
                    multi: true,
                },
                HttpOverlayService],
        })
    ], HttpOverlayModule);
    return HttpOverlayModule;
}());

/*
 * Public API Surface of a4-http-overlay-interceptor
 */

/**
 * Generated bundle index. Do not edit.
 */

export { HttpOverlayInterceptor, HttpOverlayModule, HttpOverlayService };
//# sourceMappingURL=a4-http-overlay-interceptor.js.map
